VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H8000000B&
   Caption         =   "AR Spectrum"
   ClientHeight    =   5070
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5820
   Icon            =   "SpecDisplay.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5070
   ScaleWidth      =   5820
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdClear 
      Caption         =   "MaxHold Clear"
      Height          =   495
      Left            =   3000
      TabIndex        =   3
      Top             =   4560
      Width           =   1095
   End
   Begin VB.VScrollBar scrReflvl 
      Height          =   1935
      Left            =   240
      Max             =   60
      Min             =   -60
      TabIndex        =   1
      Top             =   600
      Value           =   30
      Width           =   255
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00000000&
      Height          =   4455
      Left            =   960
      ScaleHeight     =   901.539
      ScaleMode       =   0  'Benutzerdefiniert
      ScaleTop        =   1000
      ScaleWidth      =   317
      TabIndex        =   0
      Top             =   0
      Width           =   4815
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   120
      Top             =   3600
   End
   Begin VB.Label Label4 
      Caption         =   "Label4"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   4080
      Width           =   615
   End
   Begin VB.Label Label3 
      Caption         =   "Max Hold:"
      Height          =   255
      Left            =   4320
      TabIndex        =   9
      Top             =   4680
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Sig max:"
      Height          =   255
      Left            =   1560
      TabIndex        =   8
      Top             =   4680
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Freq Peak:"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   4680
      Width           =   855
   End
   Begin VB.Label lblMaxHold 
      Caption         =   "Label1"
      Height          =   255
      Left            =   5160
      TabIndex        =   6
      Top             =   4680
      Width           =   735
   End
   Begin VB.Label lblMax 
      Caption         =   "Label1"
      Height          =   255
      Left            =   2280
      TabIndex        =   5
      Top             =   4680
      Width           =   615
   End
   Begin VB.Label lblFreq 
      Caption         =   "Label1"
      Height          =   255
      Left            =   840
      TabIndex        =   4
      Top             =   4680
      Width           =   615
   End
   Begin VB.Label lblReflvl 
      Alignment       =   1  'Rechts
      Caption         =   "Ref: 0 dB"
      Height          =   255
      Left            =   -120
      TabIndex        =   2
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Spectrum analyzer based on the source code of:
'email: takisfmf@yahoo.gr
'for more source code visit
'http://www.geocities.com/takisfmf/index.html

Option Explicit

Dim dblNbins As Double          'Number of points in the DFT,
Dim REX(16384) As Double        'Real part of input
Dim IMX(16384) As Double        'Imaginary part of input
Dim DISPLAYtrc(8193) As Double  'Trace to display
Dim MEMORYtrc(8193) As Double   'Memory trace to display / calculate
Dim TRACE1_X(8193) As Double    'Trace1 to display 8192+1
Dim TRACE1_Y(8193) As Double    'Trace1 to display
Dim strMemoryBins As String     'Number of bins coupled to memory trace
Dim blnMEMdisplay As Boolean
Dim blnMEMminustrc As Boolean
Dim blnCMDswitch As Boolean     'False if freezed, true if running
Dim dblSampleValue As Double
Dim lngTraceColor As Long
Dim lngGridBrightness As Long
Dim lngBckBrightness As Long
Dim sngReflvl As Single
Dim sngOffset As Single
Dim sngdBdiv As Single
Private MyF As Integer
Private MyD As Single
Private MyN As Single
Private txtFmin As String
Private txtFmax As String

Dim cboBins As String
Public lngSampleRate As Long














Private Sub cmdClear_Click()
lblMaxHold.Caption = "0"
End Sub

Private Sub Form_Activate()
sngReflvl = 30
lblReflvl.Caption = "Ref: " & sngReflvl & " dB"
    
    sngdBdiv = 10
    cboSRate = "22050" '22050
    cboBins = "8192" '8192
    lngSampleRate = Val(cboSRate)
  
    txtFmin = "270"
    txtFmax = Str(Val(cboSRate) / 2)
    txtFmax = "2700"
   ' scrAVG.Value = 30
    lblMaxHold.Caption = "0"
    sngdBdiv = 10
   
    blnMEMdisplay = False
    blnMEMminustrc = False
    blnCMDswitch = False
    
  
         'Call MakeDisplay
        StartInput
    lngGridBrightness = &HC0C0C0
    
 
    lngBckBrightness = vbBlack
    
    dblNbins = Val(cboBins)   'Number of samples must be  2^k  where k = integer > 1
    BUFFER_SIZE = dblNbins * 2     'Must be at least 2 * max number of bins
     Picture1.AutoRedraw = True
    
    
    
    
    MakeDisplay
    
    
    
    Timer1.Interval = 1
    Timer1.Enabled = True
    'Call Working  'This line or previous timer1 routine for slower update

End Sub

Private Sub MakeDisplay()
 
    Dim sngX As Single
    Dim sngY As Single
    Dim lngScaleSize As Long



    'If chkOverWrite.Value = 1 Then Exit Sub
    lngScaleSize = 1200
    
   'lngScaleSize = 2400
    
    Picture1.BackColor = lngBckBrightness
    Picture1.ScaleWidth = lngScaleSize     '1000 for scale, +/- 100 for boarder
    Picture1.ScaleHeight = lngScaleSize    '1000 for scale, +/- 100 for boarder
    Picture1.ScaleLeft = -100
    Picture1.ScaleTop = -100
    
    Picture1.Cls

    'Draw grid
        
    For sngX = 0 To 1000 Step 100
        Picture1.Line (sngX, 0)-(sngX, 1000), lngGridBrightness
    Next sngX
      
    For sngY = 0 To 1000 Step 125
        Picture1.Line (0, sngY)-(1000, sngY), lngGridBrightness
    Next sngY
    
    'Extra long center lines
    Picture1.Line (500, -0)-(500, 1000), lngGridBrightness
    Picture1.Line (-0, 500)-(1000, 500), lngGridBrightness
 
   
    MyD = Int(MyD)
         lblMax.Caption = MyD & " dB anl"
         If Val(lblMaxHold.Caption) < Val(lblMax.Caption) Then lblMaxHold.Caption = lblMax.Caption
         
   lblFreq.Caption = MyF & " Hz"
    

End Sub









Private Sub scrReflvl_Change()
   sngReflvl = scrReflvl.Value

   lblReflvl.Caption = "Ref: " & sngReflvl & " dB"
   Call MakeDisplayTrace(dblNbins / 2)
   Call DisplayTraces(lngTraceColor)
End Sub







Private Sub Timer1_Timer()   ' Process timer solution with variable refresh rate
     
    If fRecording = False Or (inHdr.dwFlags And WHDR_DONE) = 0 Then Exit Sub
       
    Call GetAudio
    
    Call StopInput           'Stop input, erase memory
    Call StartInput          'Start new buffer etc.
    Call DrawSpectrum
        
End Sub

Private Sub OLDTimer1_Timer()   ' Process timer solution with variable refresh rate
     
    If fRecording = False Or (inHdr.dwFlags And WHDR_DONE) = 0 Then Exit Sub
       
    Call GetAudio
    
    rc = waveInAddBuffer(hWaveIn, inHdr, Len(inHdr))
    If (rc <> 0) Then
        waveInGetErrorText rc, msg, Len(msg)
        MsgBox msg
    End If
      
    Call DrawSpectrum
        
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    
    If (fRecording) Then
        StopInput
    End If
    
End Sub

Sub GetAudio()
     
    Dim lngSample As Long
             
    lngTraceColor = RGB(0, 255, 0)
      
    For lngSample = 0 To dblNbins - 1
        Call GetMono16Sample(lngSample, dblSampleValue)
        
        REX(lngSample) = dblSampleValue
        IMX(lngSample) = 0
        
        'If dblSampleValue < -0.5 Or dblSampleValue > 0.5 Then lngTraceColor = &HFF
    Next lngSample
   
   Call FFT(CInt(dblNbins), REX, IMX)
   
End Sub


 Sub DrawSpectrum()
  
    Dim lngBin, lngSample As Long
    Dim dblX As Double
     MyD = 0
    For lngBin = 0 To dblNbins / 2
            
        dblX = Sqr(REX(lngBin) * REX(lngBin) + IMX(lngBin) * IMX(lngBin))
        dblX = 20 * Log(dblX + 0.0000001) / Log(10) 'Convert to dB's
                
     
        
      
        
            DISPLAYtrc(lngBin) = DISPLAYtrc(lngBin) + (dblX - DISPLAYtrc(lngBin)) / 10
      If DISPLAYtrc(lngBin) > MyD Then MyD = DISPLAYtrc(lngBin): MyF = lngBin * 2 * 1.344855
If lngBin > 1000 Then MyN = DISPLAYtrc(lngBin - 800)

    Next lngBin
' MyD = MyD - 25
  MyD = MyD * ((20 * Log(MyD) / 70)) - Abs(MyN)
  
  'If MyD < -0 Then MyD = 0
    Call MakeDisplayTrace(dblNbins / 2)
    Call DisplayTraces(lngTraceColor)
 
  Label4.Caption = Int(MyN)

End Sub

Private Sub MakeDisplayTrace(lngLength As Long)
    Dim lngBin As Long
    Dim lngTraceCount As Long
    Dim sngFreqMin, sngFreqMax, sngFreq As Single
    Dim dblX, dblY As Double
    
    sngFreqMin = Val(txtFmin)
    sngFreqMax = Val(txtFmax)
    
    If sngFreqMax <= sngFreqMin Then Exit Sub
 
    lngTraceCount = 0
    
    For lngBin = 0 To lngLength
   
        If blnMEMminustrc = False Then
            dblY = DISPLAYtrc(lngBin)
            dblY = 50 + sngReflvl - dblY  '50 is a good value for max dynamic range
        Else
            dblY = MEMORYtrc(lngBin) - DISPLAYtrc(lngBin)
            dblY = sngReflvl + dblY
        End If

        dblY = 125 * (dblY / sngdBdiv)              '125 per div vertical
           
        If dblY < -50 Then dblY = -50
        If dblY > 1000 Then dblY = 1000
       
        TRACE1_Y(lngTraceCount) = dblY
      
        
      
        sngFreq = CSng(lngBin) / dblNbins * lngSampleRate
             
        If sngFreq < sngFreqMin Then
            dblX = 0
         End If
        
        If sngFreq >= sngFreqMin And sngFreq <= sngFreqMax Then
            dblX = 1000 * (sngFreq - sngFreqMin) / (sngFreqMax - sngFreqMin)
        End If
        
        If sngFreq > sngFreqMax Then Exit For  'Finish
        
        TRACE1_X(lngTraceCount) = dblX
        TRACE1_X(lngTraceCount + 1) = 9999 'End of array
        
   
        
        If sngFreq >= sngFreqMin And sngFreq <= sngFreqMax Then
            lngTraceCount = lngTraceCount + 1
        End If
        
    Next lngBin
    
End Sub

Private Sub DisplayTraces(ByVal lngTheColor)
   Dim intN, intX, intY As Integer
      
   Dim lngTrace1Color As Long
  
   
   'Set the trace colors

   
   lngTrace1Color = vbYellow 'vbGreen
   

           
   Call MakeDisplay

   'First memory trace 2 then the normal trace1
   For intN = 1 To 16384
       

       
      If TRACE1_X(intN) = 9999 Then Exit For
      
      Picture1.Line (TRACE1_X(intN - 1), TRACE1_Y(intN - 1))-(TRACE1_X(intN), TRACE1_Y(intN)), lngTrace1Color
   Next intN
  
 End Sub




